/* http_init.h */

int init_http(void)
{
 char *t,*ins;
 int contlen,i;

 t=getenv("REQUEST_METHOD");
 if(t==0) {
  printf("Cannot execute file\n");
  exit(0);
 }
 printf("Content-type: text/html\n\n");
 if(strcmp(t,"GET")==0) {
  t=getenv("QUERY_STRING");
  if(t==0) t="";
  ins=malloc(strlen(t)+16);
  strcpy(ins,t);
 } else {
  t=getenv("CONTENT_LENGTH");
  if(t==0 || (atoi(t)<=0)) {
   server_error("Content length unknown");
   return 0;
  }
  contlen=atoi(t);
  ins=malloc(contlen+16);
  if(ins==0) {
   server_error("The server has run out of memory");
   return 1;
  }
  for(i=0;i<contlen;i++)
   ins[i]=fgetc(stdin);
  ins[contlen]=0;
 }
 return make_content(ins);
}

